package nl.amis.odtug.dashboard.view;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Set;
import java.util.List;
import java.util.Map;

import javax.faces.bean.ManagedBean;

@ManagedBean(name = "myInvokableMap")
public class MyInvokableMap implements Map {


    static final int SETTING_PARAMETERS = 1;
    static final int INVOKING = 2;

    int mode = SETTING_PARAMETERS;

    List<Object> params = new ArrayList<Object>();


    public Object get(Object key) {
        boolean isString = key instanceof String;
        // if the init is passed, this object is reinitialized for the next invocation
        if (isString && ((String)key).equalsIgnoreCase("init")) {
            mode = SETTING_PARAMETERS;
            params.clear();
            return this;
        }
        // if set is passed, we can expect the next call to get to pass the value of the next attribute
        if (isString && ((String)key).equalsIgnoreCase("set")) {
            mode = SETTING_PARAMETERS;
            return this;
        }
        // if invoke is passed, the next call to get will pass the key that optionally identified the method to invoke; we switch now from SETTING_PARAMETERS mode to INVOKING mode
        if (isString && ((String)key).equalsIgnoreCase("invoke")) {
            mode = INVOKING;
            return this;
        }
        if (mode == SETTING_PARAMETERS) {
            params.add(key); // store this parameter with the current number of entries as the key; that means that parameters are stored in params with keys 0..x where x is one less than the number of parameters
            return this;
        }
        if (mode ==
            INVOKING) { // now depending on the value of key, we can decide to invoke the method that is called for

            if (((String)key).equalsIgnoreCase("aboveZero")) {
                return ((oracle.jbo.domain.Number)params.get(0)).compareTo(0) > 0;
            } else if (((String)key).equalsIgnoreCase("width")) {
                Long maxWidth = (Long)params.get(0);
                Long maxValue = (Long)params.get(1);
                oracle.jbo.domain.Number actualValue = ((oracle.jbo.domain.Number)params.get(2));
                double w = actualValue.abs().floatValue() / maxValue;
                Long width = Double.valueOf(w * maxWidth).longValue();
                return width;
            } else if (((String)key).equalsIgnoreCase("command")) {
                // Execute command, whatever it is
                return null;
            }
        }
        return null;
    }

      public Object put(Object key, Object value) {
        return null;
      }

      public Object remove(Object key) {
        return null;
      }

      public void putAll(Map t) {
      }

      public void clear() {
      }

      public Set keySet() {
        return null;
      }

      public Collection values() {
        return null;
      }

      public Set entrySet() {
        return null;
      }

      public boolean equals(Object o) {
        return false;
      }

      public int hashCode() {
        return 0;
      }

        public int size() {
          return 0;
        }

        public boolean isEmpty() {
          return false;
        }

        public boolean containsKey(Object key) {
          return true;
        }

        public boolean containsValue(Object value) {
          return true;
        }

    }

